#! /usr/bin/env node

// 引入的模块
var fs = require('fs'), path = require('path');

// 已载入过的文件列表
var loadedList = {};
// 文件树
var treeContent = [], treeIndex = 0;
// 命令参数
var argOpts = {'path': null, 'file': null, 'type': null};

// 入口
function combine(path, file, type) {
	
	argOpts['path'] = path;
	argOpts['file'] = file;
	argOpts['type'] = type;
	
	// 文件合并时间
	var startTime = new Date();
	
	var path = argOpts['path'] = (fs.realpathSync(argOpts['path']) + '/');
	var file = parseNS(argOpts['file'], argOpts['type']);

	var content = combineFile(path, file);
		
	content = '/*\ncombineTime: ' + (new Date() - startTime) + '\ncombineTree:\n' + treeContent.join('\n') + '\n*/\n' + content;
	
	return content;
}

// 合并文件
function combineFile(path, file) {
	var content = getFileContent(path + file);
	
	treeContent.push(Array(treeIndex + 1).join(' | ') + ' +---- ' + file + (loadedList[file]? ' (skipped)': ''));
	
	if(loadedList[file] != null) {return '/* skip file: ' + file + ' */';}
	
	loadedList[file] = file;
	
	treeIndex ++;		

	content = content.replace(/(^|\n\s*)\$import\s*\(\s*([\'\"])(.+)\2\s*\);?/ig, function() {
		var file = parseNS(arguments[3], argOpts['type']);
		return arguments[1] + combineFile(path, file);
	});

	treeIndex --;

	return content;
}

// 读取并返回文件内容
function getFileContent(file) {
	try{
		var content = fs.readFileSync(file, 'utf-8');
		return content;
	}
	catch(e) {
		return '/*' + e + '*/';
	}
}

// 分析命名空间为文件路径
function parseNS(ns, type) {
	return type == 'js'? ns.replace(/\./g, '/') + '.js': ns;
}
exports.combine = combine;

